/* disp.c */

#include <stdio.h>
#include <math.h>
#include <matrix.h>

ivector new_ivector();
vector  new_vector();
matrix  new_matrix();
void    errorexit();
void    find_range();


/*      main program
 *      the finite element method for the Stokes equation
 */


main(argc, argv)
int argc;
char **argv;
{
  FILE *f1;
  int i,j,k;
  int U,T,SIZE,N,D,ND;
  int *cum,**num;
  double xmin, xmax, ymin, ymax, dx, dy;
  vector x,y;
  

  if((f1 = fopen(argv[1],"r")) == NULL){
    fprintf(stderr, "Can't open %s",argv[1]);
    exit(1);
  }

  fscanf(f1, "%d %d", &T, &U);

  x = new_vector(U);
  y = new_vector(U);
  for(i=0;i<U;i++){
    fscanf(f1, "%lf %lf", &x[i], &y[i]);
  }

  num = (int **)malloc( T * sizeof(void *) );
  if(num == NULL) printf("ǤбѤΥ꡼­ޤ\n");
  for(i=0;i<T;i++){
    num[i] = (int *)malloc(sizeof(int) * 6);
    if(num[i] == NULL){
      printf("ǤбѤΥ꡼­ޤ\n");
    }
  }
  for(i=0;i<T;i++){
    for(j=0;j<6;j++){
      fscanf(f1, "%d", &num[i][j]);
    }
  }


  fclose(f1);
  

  openpl();
/*    find_range(U, x, y, &xmin, &xmax, &ymin, &ymax);
    dx = (xmax - xmin) / 20;
    dy = (ymax - ymin) / 20;
    fspace2(xmin -dx, ymin - dy, xmax + dx, ymax + dy);
*/
  
  fspace2(-0.1,-0.1, 1.1,1.1);
  erase(0);
    for(i=0;i<T;i++){
        fmove(x[num[i][0]],y[num[i][0]]);
        for(j=2;j>=0;j--){
            fcont(x[num[i][j]],y[num[i][j]]);
	  }
      }
    mkplot("disp.plot");
    closepl();

    return 0;
}


void find_range(nnode, x, y, xmin, xmax, ymin, ymax)
int nnode;
double x[], y[], *xmin, *xmax, *ymin, *ymax;
{
    int i;
    *xmin = *xmax = x[0];
    *ymin = *ymax = y[0];
    for (i = 0; i < nnode; i++) {
        if (x[i] > *xmax)
            *xmax = x[i];
        else if (x[i] < *xmin)
            *xmin = x[i];
        if (y[i] > *ymax)
            *ymax = y[i];
        else if (y[i] < *ymin)
            *ymin = y[i];
      }
  }


void
errorexit(msg)
char *msg;
{
    fprintf(stderr, msg);
    exit(1);
  }
