
/*
 * fluid3.c --- ַв
 *   ccmg fluid3.c
 *
 *   g_out -vfm 4,3 0.3 Kudo
 *     Ĥ 4,  3 Υե졼ࡣ0.3 ܤ˳硣
 *   lpr Kudo.ps
 */

#include <math.h>
#include <stdio.h>
#include <glsc.h>
#include <matrix.h>

main(argc, argv)
int argc;
char **argv;
{
    FILE *f1, *f2;
    int i, j, U, T, SIZE;
    double k;
    int *cum, **num;
    vector x, y, u;

    if (argc != 3) {
      fprintf(stderr, "usage: %s ΰǡ ͥǡ\n", argv[0]);
      exit(0);
    }

    if ((f1 = fopen(argv[1], "r")) == NULL) {
        fprintf(stderr, "Can't open %s\n", argv[1]);
        exit(1);
    }
    if ((f2 = fopen(argv[2], "r")) == NULL) {
        fprintf(stderr, "Can't open %s\n", argv[2]);
        exit(2);
    }
    fscanf(f1, "%d %d", &T, &U);

    x = new_vector(U);
    y = new_vector(U);
    for (i = 0; i < U; i++) {
        fscanf(f1, "%lf %lf", &x[i], &y[i]);
    }

    num = (int **) malloc(T * sizeof(void *));
    if (num == NULL) {
        fprintf(stderr, "ǤбѤΥ꡼­ޤ\n");
        exit(3);
    }
    for (i = 0; i < T; i++) {
        num[i] = (int *) malloc(sizeof(int) * 6);
        if (num[i] == NULL) {
            fprintf(stderr, "ǤбѤΥ꡼­ޤ\n");
            exit(4);
        }
    }
    for (i = 0; i < T; i++)
        for (j = 0; j < 6; j++)
            fscanf(f1, "%d", &num[i][j]);

    if ((cum = (int *) malloc(sizeof(int) * U)) == NULL) {
        fprintf(stderr, "ֹѤΥ꡼­ޤ \n");
        exit(5);
    }
    for (i = 0; i < U; i++)
        fscanf(f1, "%d", &cum[i]);

    fscanf(f1, "%d", &SIZE);
    fclose(f1);

    u = new_vector(SIZE);
    k= 0.0;
    while (!feof(f2)) {
        char buf[1024];
        for (i = 0; i < SIZE; i++) {
            if (fgets(buf, sizeof(buf), f2) == NULL)
                break;
            sscanf(buf, "%lf", &u[i]);
        }
#ifdef  SLEEP
        sleep(1);
#endif
        k++;
        glsc(U, T, SIZE, num, cum, x, y, u, k);
        
    }
    fclose(f2);

    printf("end\n");
    g_sleep(-1.0);
    g_term();

    return 0;
}

glsc(U, T, SIZE, num, cum, x, y, u, k)
int U, T,  SIZE, **num, *cum;
double k;
vector x, y, u;
{
    int i, j;
    double widx, widy, Lx, Ly;

    static int glsc_initialized = 0;
    static double left, right, top, bottom;

    if (!glsc_initialized) {
        printf("glsc_initialize glsc\n");
        left = right = x[0];
        top = bottom = y[0];

        for (i = 1; i < U; i++) {
            if (left > x[i]) left = x[i]; else if (right < x[i]) right = x[i];
            if (top < y[i]) top = y[i]; else if (bottom > y[i]) bottom = y[i];
        }

        widx = fabs(left - right); widy = fabs(top - bottom);

        left -= 0.1 * widx; right += 0.1 * widx;
        top += 0.1 * widy;  bottom -= 0.1 * widy;

        widx = fabs(left - right);
        widy = fabs(top - bottom);

        if (widx >= widy) {
            Lx = 150.0; Ly = Lx * widy / widx;
        } else {
            Ly = 150.0; Lx = Ly * widx / widy;
        }

        g_init("Kudo", Lx + 10.0, Ly + 10.0);
        g_device(3);
        g_def_scale(0, left, right, bottom, top, 5.0, 5.0, Lx, Ly);
        g_sel_scale(0);
        g_def_text(0, G_RED, G_FONT_TIMES_24);
        g_sel_text(0);
        glsc_initialized = 1;
    }
#ifdef ORIGINAL
    printf("ֹ :  \n");
    printf("       \n");
    printf("       \n");
    printf("طʤοֹϡ ");
    scanf("%d", &i);
#else
    i = 6;
#endif
    g_cls();
    g_line_color(i);
    g_area_color(i);
    g_box(left, right, bottom, top, 1, 1);

    domain(T, num, x, y, k);
    flow(U, cum, x, y, u);

}

domain(T, num, x, y, k)
int T, **num;
double k;
vector x, y;
{
    int i, j, col;
    double s, zx[3], zy[3];
    char message[80];

#ifdef ORIGINAL
    printf("ΰοֹϡ ");
    scanf("%d", &col);
#else
    col =  7;
#endif

    g_def_line(0, col, 0, 4);
    g_sel_line(0);
    g_area_color(col);

    for (i = 0; i < T; i++) {
        for (j = 0; j < 3; j++) {
            zx[j] = x[num[i][j]];
            zy[j] = y[num[i][j]];
        }
        g_polygon(zx, zy, 3, 0, 1);
    }
    s= k*0.1;
    sprintf(message, "t=%4.2f", s);
    g_text(70.0, 15.0, message);
}

flow(U, cum, x, y, u)
int U, *cum;
vector x, y, u;
{
    int i, col;
    double d;

#ifdef ORIGINAL
    printf("οֹϡ "); scanf("%d", &col);
#else
    col = 0;
/*G_YELLOW;*/
#endif
    g_def_line(0, col, 0, 0);
    g_sel_line(0);

#ifdef ORIGINAL
    printf("Ĺϡ "); scanf("%lf", &d);
#else
    d = 0.1;
#endif

    for (i = 0; i < U; i++) {
        arrow(x[i], y[i], x[i] + d * u[cum[i]], y[i] + d * u[cum[i] + 1]);
    }
}

arrow(x1, y1, x2, y2)
double x1, y1, x2, y2;
{
    double x3, y3, x4, y4;

    x3 = 0.1 * ((x1 + 9.0 * x2) + (y2 - y1));
    x4 = 0.1 * ((x1 + 9.0 * x2) - (y2 - y1));
    y3 = 0.1 * ((y1 + 9.0 * y2) - (x2 - x1));
    y4 = 0.1 * ((y1 + 9.0 * y2) + (x2 - x1));

    g_move(x1, y1);
    g_plot(x2, y2);
    g_plot(x3, y3);
    g_move(x2, y2);
    g_plot(x4, y4);
}



