
/*  press-mk.c ---  */
/*
 *  ccmg press-mk.c
 *  Meta filename; Press
*/


#include <math.h>
#include <stdio.h>
#include <glsc.h>
#include <matrix.h>

main(argc, argv)
int argc;
char **argv;
{
    FILE *f1, *f2;
    double t;
    int i, j, k, U, T, tempx, tempy, SIZE, size, N;
    imatrix num_x, num_y;   
    int *cum, **num;
    vector x, y, u;
    matrix  p;

    if (argc != 3) {
      fprintf(stderr, "usage: %s ΰǡ ͥǡ\n", argv[0]);
      exit(0);
    }

    if ((f1 = fopen(argv[1], "r")) == NULL) {
        fprintf(stderr, "Can't open %s\n", argv[1]);
        exit(1);
      }
    if ((f2 = fopen(argv[2], "r")) == NULL) {
        fprintf(stderr, "Can't open %s\n", argv[2]);
        exit(2);
      }
    fscanf(f1, "%d %d", &T, &U);
    printf("T=%d, U=%d\n", T, U);

    x = new_vector(U);
    y = new_vector(U);
    for (i = 0; i < U; i++) {
        fscanf(f1, "%lf %lf", &x[i], &y[i]);
      }
   num = (int **) malloc(T * sizeof(void *));
    if (num == NULL) {
        fprintf(stderr, "ǤбѤΥ꡼­ޤ\n");
        exit(3);
      }
    for (i = 0; i < T; i++) {
        num[i] = (int *) malloc(sizeof(int) * 6);
        if (num[i] == NULL) {
            fprintf(stderr, "ǤбѤΥ꡼­ޤ\n");
            exit(4);
          }
      }
    for (i = 0; i < T; i++)
        for (j = 0; j < 6; j++)
            fscanf(f1, "%d", &num[i][j]);

    if ((cum = (int *) malloc(sizeof(int) * U)) == NULL) {
        fprintf(stderr, "ֹѤΥ꡼­ޤ \n");
        exit(5);
      }
    for (i = 0; i < U; i++)
        fscanf(f1, "%d", &cum[i]);

    fscanf(f1, "%d", &SIZE);
    fclose(f1);

    /* size= T / 2 +1; */
    
   /* N= sqrt(T/2); */
     N = 14;            /*14 ʬξ硣*/  
    size = N + 1;
    p= new_matrix(size, size);
    num_x = new_imatrix(T, 6);
    num_y = new_imatrix(T, 6);


    for(k=0; k<T; k++){
      for(j=0; j< 6; j++){
        tempx= num[k][j]% size;
        tempy= num[k][j]/ size;
        num_x[k][j]= tempx;
        num_y[k][j]= tempy;
      }
    }
   

   u = new_vector(SIZE);
    t =  0.0;
    while (!feof(f2)) {
        char buf[1024];
        for (i = 0; i < SIZE; i++) {
            if (fgets(buf, sizeof(buf), f2) == NULL)
                break;
            sscanf(buf, "%lf", &u[i]);
          }
        k = 0;
        for (i=0; i <= N; i++) {
          for(j=0; j <= N; j++) {
            k += 2;
            p[i][j] = u[k]; k++;
            if (j < N) k += 2;
          }
          k += (N*2+1)*2;
        }
        printf("\n");
        for (j = N; j >= 0; j--) {
          for (i = 0; i <= N; i++)
            printf("%4.1f ",  p[i][j]);
          printf("\n");
        }
/*        sleep(1); */
/*      }  */
        t++;
        glsc(U, T, SIZE, size, num, cum, x, y, u, p, t); 
     } 
    fclose(f2);

    printf("end\n");
    g_sleep(-1.0);
    g_term();

    return 0;
  }

glsc(U, T, SIZE, size, num, cum, x, y, u, p, t)
int U, T, SIZE, size,**num, *cum;
double t;
vector x, y, u;
matrix p;
{
    int i, j, k;
    double widx, widy, Lx, Ly;

    static int glsc_initialized = 0;
    static double left, right, top, bottom;

    if (!glsc_initialized) {
        printf("glsc_initialize glsc\n");
        left = right = x[0];
        top = bottom = y[0];

        for (i = 1; i < U; i++) {
            if (left > x[i]) left = x[i]; else if (right < x[i]) right = x[i];
            if (top < y[i]) top = y[i]; else if (bottom > y[i]) bottom = y[i];
          }

        widx = fabs(left - right); widy = fabs(top - bottom);

        left -= 0.1 * widx; right += 0.1 * widx;
        top += 0.1 * widy;  bottom -= 0.1 * widy;

        widx = fabs(left - right);
        widy = fabs(top - bottom);

        if (widx >= widy) {
            Lx = 150.0; Ly = Lx * widy / widx;
          } else {
            Ly = 150.0; Lx = Ly * widx / widy;
          }

        g_init("Press", Lx + 10.0, Ly + 10.0);
        g_device(3);
        g_def_scale(0, left, right, bottom, top, 5.0, 5.0, Lx, Ly);
        g_sel_scale(0);
        g_def_text(0, G_RED, G_FONT_TIMES_24);
        g_sel_text(0);
/*        g_cls(); */
        glsc_initialized = 1;
      }
#ifdef ORIGINAL
    printf("ֹ :  \n");
    printf("       \n");
    printf("       \n");
    printf("طʤοֹϡ ");
    scanf("%d", &i);
#else
    i = 6;
#endif
    g_cls();
    g_line_color(i);
    g_area_color(i);
    g_box(left, right, bottom, top, 1, 1);

    domain(T, num, x, y, t);
    for (k = 0; k <= 120; k++) {
      g_line_color(k % 7 + 1);
      g_contln2(0.0, 1.0, 0.0, 1.0, p, size, size, -2+0.05*k);
      g_sleep(1);
  }
  }

domain(T, num, x, y, t)
int T, **num;
double t;
vector x, y;
{
    int i, j, col;
    double tt,zx[3], zy[3];
    char message[80];
    tt=t*0.1;

#ifdef ORIGINAL
    printf("ΰοֹϡ ");
    scanf("%d", &col);
#else
    col = 7;
#endif

    g_def_line(0, col, 0, 0);
    g_sel_line(0);
    g_area_color(col);

    for (i = 0; i < T; i++) {
        for (j = 0; j < 3; j++) {
            zx[j] = x[num[i][j]];
            zy[j] = y[num[i][j]];
          }
        g_polygon(zx, zy, 3, 0, 1);
      }
    sprintf(message, "t=%4.2f", tt);
    g_text(70.0, 15.0, message);
  }









